<?php
/*
Plugin Name: WP-Facebook Like This
Plugin URI: http://www.lejournaldublog.com/plugin-wordpress-facebook-like-wp-fb-like-this/
Description: This plugin allows your visitors to "like" your posts via new Facebook Like Function. You'll have to create a Facebook application to use this plugin.
Version: 0.2
Author: Milky Interactive
Author URI: http://www.milky-interactive.com

Copyright 2010  Milky Interactive  (email : contact@milky-interactive.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

~Changelog:
0.2
- Inclusion method added: auto or manual
- Widget layout options added
- No more app ID required
0.1
First release (iFrame support only)

*/

// WP Hooks
add_action('admin_menu', 'fblikethis_menu');
//add_action('wp_head', 'fblikethis_head_adds');
//add_action('wp_footer', 'fblikethis_footer_adds');
if (get_option('fblt_autoinc') == "Yes") add_filter('the_content', 'fblikethis_post_adds');
//add_filter('language_attributes', 'fblikethis_lang_adds');
register_activation_hook(__FILE__, 'fblikethis_install');

function fblikethis_menu() {
	if(current_user_can('manage_options')) {
		add_options_page('WP-FacebookLikeThis', 'WP-FacebookLikeThis',1,basename(__FILE__),'fblikethis_options');
	}
}

function fblikethis_install() {
	$fblt_fbappid = get_option('fblt_fbappid');
	$fblt_image = get_option('fblt_image');
	$fblt_method = get_option('fblt_method');
	$fblt_autoinc = get_option('fblt_autoinc');
  $fblt_style = get_option('fblt_style');
  $fblt_faces = get_option('fblt_faces');
  $fblt_width = get_option('fblt_width');
  $fblt_verb = get_option('fblt_verb');
  $fblt_font = get_option('fblt_font');
  $fblt_color = get_option('fblt_color');


	if(empty($fblt_fbappid)) update_option('fblt_fbappid', '');
	if(empty($fblt_image)) update_option('fblt_image', '');
	if(empty($fblt_method)) update_option('fblt_method', 'iframe');
	if(empty($fblt_autoinc)) update_option('fblt_autoinc', 'Yes');
	if(empty($fblt_style)) update_option('fblt_style', 'standard');
	if(empty($fblt_faces)) update_option('fblt_faces', 'true');
	if(empty($fblt_width)) update_option('fblt_width', '450');
	if(empty($fblt_verb)) update_option('fblt_verb', 'like');
	if(empty($fblt_font)) update_option('fblt_font', '');
	if(empty($fblt_color)) update_option('fblt_color', 'light');

}

function fblikethis_options() {
	global $wpdb;
	
  //Loading options
  $fblt_fbappid_label = 'fblt_fbappid';
  $fblt_fbappid_value = strip_tags(stripslashes(get_option($fblt_fbappid_label)));
  
  $fblt_image_label = 'fblt_image';
  $fblt_image_value = strip_tags(stripslashes(get_option($fblt_image_label)));

  $fblt_method_label = 'fblt_method';
  $fblt_method_value = strip_tags(stripslashes(get_option($fblt_method_label)));

  $fblt_autoinc_label = 'fblt_autoinc';
  $fblt_autoinc_value = strip_tags(stripslashes(get_option($fblt_autoinc_label)));

  $fblt_style_label = 'fblt_style';
  $fblt_style_value = strip_tags(stripslashes(get_option($fblt_style_label)));

  $fblt_faces_label = 'fblt_faces';
  $fblt_faces_value = strip_tags(stripslashes(get_option($fblt_faces_label)));

  $fblt_width_label = 'fblt_width';
  $fblt_width_value = strip_tags(stripslashes(get_option($fblt_width_label)));

  $fblt_verb_label = 'fblt_verb';
  $fblt_verb_value = strip_tags(stripslashes(get_option($fblt_verb_label)));

  $fblt_font_label = 'fblt_font';
  $fblt_font_value = strip_tags(stripslashes(get_option($fblt_font_label)));

  $fblt_color_label = 'fblt_color';
  $fblt_color_value = strip_tags(stripslashes(get_option($fblt_color_label)));

    
  $fblt_hidden = 'fblt_hidden';
  
  // Form was posted ?
  if($_POST[$fblt_hidden] == 'Y') {
		$fblt_fbappid_value = strip_tags(stripslashes($_POST[$fblt_fbappid_label]));
		$fblt_image_value = strip_tags(stripslashes($_POST[$fblt_image_label]));
		$fblt_method_value = strip_tags(stripslashes($_POST[$fblt_method_label]));
		$fblt_autoinc_value = strip_tags(stripslashes($_POST[$fblt_autoinc_label]));
		$fblt_style_value = strip_tags(stripslashes($_POST[$fblt_style_label]));
		$fblt_faces_value = strip_tags(stripslashes($_POST[$fblt_faces_label]));
		$fblt_width_value = strip_tags(stripslashes($_POST[$fblt_width_label]));
		$fblt_verb_value = strip_tags(stripslashes($_POST[$fblt_verb_label]));
		$fblt_font_value = strip_tags(stripslashes($_POST[$fblt_font_label]));
		$fblt_color_value = strip_tags(stripslashes($_POST[$fblt_color_label]));
		
		if ($fblt_faces_value == "") $fblt_faces_value = "false";

		
		update_option($fblt_fbappid_label, $fblt_fbappid_value);
		update_option($fblt_image_label, $fblt_image_value);
		update_option($fblt_method_label, $fblt_method_value);
		update_option($fblt_autoinc_label, $fblt_autoinc_value);
		update_option($fblt_style_label, $fblt_style_value);
		update_option($fblt_faces_label, $fblt_faces_value);
		update_option($fblt_width_label, $fblt_width_value);
		update_option($fblt_verb_label, $fblt_verb_value);
		update_option($fblt_font_label, $fblt_font_value);
		update_option($fblt_color_label, $fblt_color_value);
		
		?>
		<div class="updated"><p><strong><?php _e('Hurray! Options have been saved.', 'fblt' ); ?></strong></p></div>
		<?php
  }
  

	//Displaying regular form
 
  echo '<div class="wrap">';
  echo '<h2>'. __('Options &bull; WP-FacebookLikeThis', 'fblt') .'</h2>';
	?>
  <script type="text/javascript">
  	function fblt_fbsettings(methodvalue) {
  		elem = document.getElementById('fblt_fbsettings');
  		if (methodvalue == 'iframe') {
  			elem.style.display = 'none';
  		} else {
	   		elem.style.display = 'block'; 		
  		}
  	}
  </script>
	<form name="fblt" method="post" action="">
	
		<input type="hidden" name="<?php echo $fblt_hidden; ?>" value="Y">

		<h3><?php _e("Plugin settings", 'fblt'); ?></h3>
		
		<p><?php _e("Automatic include:", 'fblt' ); ?> 
			<select name="<?php echo $fblt_autoinc_label; ?>">
				<option value="Yes" <?php if ($fblt_autoinc_value == "Yes") echo "selected"; ?>><?php _e("Yes", 'fblt' ); ?></option>
				<option value="No" <?php if ($fblt_autoinc_value == "No") echo "selected"; ?>><?php _e("No", 'fblt' ); ?></option>
			</select> <small>(<?php _e('ie. do you want this plugin automatically include "Like" button under each post?', 'fblt'); ?>).</small>
			<br /><?php _e('Note that you can include <strong>&lt;?php fblikethis_button(); ?&gt;</strong> to your template page to display this widget.', 'fblt'); ?>
		</p>
		
		<p><?php _e("Method (not available yet):", 'fblt' ); ?> 
			<select name="<?php echo $fblt_method_label; ?>" onChange="fblt_fbsettings(this.value)">
				<option value="iframe" <?php if ($fblt_method_value == "iframe") echo "selected"; ?>>iFrame</option>
				<option value="xfbml" <?php if ($fblt_method_value == "xfbml") echo "selected"; ?> disabled>XFBML</option>
			</select> <small>(<?php _e('ie. advanced use only', 'fblt'); ?>).</small>
		</p>

		<h3><?php _e("Layout settings", 'fblt'); ?></h3>

		<p><?php _e("Layout style:", 'fblt' ); ?> 
			<select name="<?php echo $fblt_style_label; ?>">
				<option value="standard" <?php if ($fblt_style_value == "standard") echo "selected"; ?>><?php _e("Standard", 'fblt' ); ?></option>
				<option value="button_count" <?php if ($fblt_style_value == "button_count") echo "selected"; ?>><?php _e("Button count", 'fblt' ); ?></option>
			</select> <small>(<?php _e('ie. choose "standard" to show the "like" button, faces, and names. "Button count" will only show how many likers you have', 'fblt'); ?>).</small>
		</p>
		
		<p><?php _e("Show Faces:", 'fblt' ); ?>
			<input type="checkbox" name="<?php echo $fblt_faces_label; ?>" value="true" <?php if ($fblt_faces_value == "true") echo "checked"; ?> /> <small>(<?php _e('ie. do you want to show "likers" faces?', 'fblt'); ?>).</small>
		</p>

		<p><?php _e("Widget width (optional):", 'fblt' ); ?> 
			<input type="text" name="<?php echo $fblt_width_label; ?>" value="<?php echo $fblt_width_value; ?>" size="20"> <small>(<?php _e('ie. if you have layout issues', 'fblt'); ?>).</small>
		</p>

		<p><?php _e("Verb to display:", 'fblt' ); ?> 
			<select name="<?php echo $fblt_verb_label; ?>">
				<option value="like" <?php if ($fblt_verb_value == "like") echo "selected"; ?>><?php _e("Like", 'fblt' ); ?></option>
				<option value="recommend" <?php if ($fblt_verb_value == "recommend") echo "selected"; ?>><?php _e("Recommend", 'fblt' ); ?></option>
			</select> <small>(<?php _e('ie. two verbs, two ways to suggest you are interested: recommend or like this article', 'fblt'); ?>).</small>
		</p>

		<p><?php _e("Font:", 'fblt' ); ?> 
			<select name="<?php echo $fblt_font_label; ?>">
				<option value="" <?php if ($fblt_font_value == "") echo "selected"; ?>><?php _e("", 'fblt' ); ?></option>				
				<option value="arial" <?php if ($fblt_font_value == "arial") echo "selected"; ?>><?php _e("Arial", 'fblt' ); ?></option>
				<option value="lucida+grande" <?php if ($fblt_font_value == "lucida+grande") echo "selected"; ?>><?php _e("Lucida Grande", 'fblt' ); ?></option>
				<option value="segoe+ui" <?php if ($fblt_font_value == "segoe+ui") echo "selected"; ?>><?php _e("Segoe UI", 'fblt' ); ?></option>				
				<option value="tahoma" <?php if ($fblt_font_value == "tahoma") echo "selected"; ?>><?php _e("Tahoma", 'fblt' ); ?></option>				
				<option value="trebuchet+ms" <?php if ($fblt_font_value == "trebuchet+ms") echo "selected"; ?>><?php _e("Trebuchet MS", 'fblt' ); ?></option>				
				<option value="verdana" <?php if ($fblt_font_value == "verdana") echo "selected"; ?>><?php _e("Verdana", 'fblt' ); ?></option>				
			</select> <small>(<?php _e('ie. use the standard Facebook font or choose one!', 'fblt'); ?>).</small>
		</p>

		<p><?php _e("Color scheme:", 'fblt' ); ?> 
			<select name="<?php echo $fblt_color_label; ?>">
				<option value="light" <?php if ($fblt_color_value == "light") echo "selected"; ?>><?php _e("Light", 'fblt' ); ?></option>
				<option value="dark" <?php if ($fblt_color_value == "dark") echo "selected"; ?>><?php _e("Dark", 'fblt' ); ?></option>
				<option value="evil" <?php if ($fblt_color_value == "evil") echo "selected"; ?>><?php _e("Evil", 'fblt' ); ?></option>
			</select> <small>(<?php _e('ie. color scheme of this widget. Is this really useful?', 'fblt'); ?>).</small>
		</p>
		
		<div id="fblt_fbsettings" <?php if ($fblt_method_value == "iframe"): ?>style="display:none;"<?php endif; ?>>
			<h3><?php _e("Facebook settings (for XFBML purpose)", 'fblt'); ?></h3>
			
			<p><?php _e("Facebook app ID:", 'fblt' ); ?> 
				<input type="text" name="<?php echo $fblt_fbappid_label; ?>" value="<?php echo $fblt_fbappid_value; ?>" size="20"> <small>(<?php _e('ie. you must have created an application for your blog', 'fblt'); ?>).</small>
			</p>
			
			<p><?php _e("Facebook pic (optional):", 'fblt' ); ?> 
				<input type="text" name="<?php echo $fblt_image_label; ?>" value="<?php echo $fblt_image_value; ?>" size="20"> <small>(<?php _e('ie. published content image url (at least 50x50px)', 'fblt'); ?>).</small>
			</p>
		</div>
		
		<p><strong>Ultimate tip</strong>: you can customize plugin appearance by defining the <em>.like</em> CSS class</p>

		<p class="submit">
			<input type="submit" name="Submit" value="<?php _e('Update Options', 'fblt' ) ?>" />
		</p>

	</form>
	
	<hr/>
	
	<!-- PayPal in action! -->
	<strong><?php _e('Do you mind about our work? Please support us!', 'fblt'); ?></strong>
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
		<input type="hidden" name="cmd" value="_s-xclick">
		<input type="hidden" name="hosted_button_id" value="9246512">
		<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
		<img alt="" border="0" src="https://www.paypal.com/fr_FR/i/scr/pixel.gif" width="1" height="1">
	</form>
	
	<p><em>The <a href="http://www.milky-interactive.com">Milky Interactive</a> team.</em></p>
  
	<?php
  echo '</div>';
}

function fblikethis_head_adds() {
	// Added to WP Head section
	echo "\n<meta property=\"og:title\" content=\"".wp_title('',false)."\" />\n";
	echo "<meta property=\"og:image\" content=\"".get_option('fblt_image')."\" />\n";
	echo "<meta property=\"og:type\" content=\"blog\" />\n";
	echo "<meta property=\"og:site_name\" content=\"".get_bloginfo('name')."\" />\n";
	echo "<meta property=\"og:description\" content=\"".get_bloginfo('description')."\" />\n";
	echo "<meta property=\"fb:app_id\" content=\"".get_option('fblt_fbappid')."\" />\n";
}

function fblikethis_footer_adds() {
	// Added to WP Footer section
	echo "\n<div id=\"fb-root\"></div>
					<script>
					  window.fbAsyncInit = function() {
					    FB.init({appId: '".get_option('fblt_fbappid')."', status: true, cookie: true,
					             xfbml: true});
					  };
					  (function() {
					    var e = document.createElement('script'); e.async = true;
					    e.src = document.location.protocol +
					      '//connect.facebook.net/en_US/all.js';
					    document.getElementById('fb-root').appendChild(e);
					  }());
					</script>\n";
}

function fblikethis_lang_adds($content) {
	return $content." xmlns:og=\"http://opengraphprotocol.org/schema/\" xmlns:fb=\"http://developers.facebook.com/schema/\" xml:lang=\"fr\" lang=\"fr\" dir=\"ltr\"";
}

function fblikethis_button($method="iframe",$echo=true) {
  $fblt_style_value = strip_tags(stripslashes(get_option('fblt_style')));
  $fblt_faces_value = strip_tags(stripslashes(get_option('fblt_faces')));
  $fblt_width_value = strip_tags(stripslashes(get_option('fblt_width')));
  $fblt_verb_value = strip_tags(stripslashes(get_option('fblt_verb')));
  $fblt_font_value = strip_tags(stripslashes(get_option('fblt_font')));
  $fblt_color_value = strip_tags(stripslashes(get_option('fblt_color')));
  
  $fblt_add = "\n<div class=\"like\">\n";
  
	if ($method == "iframe") {
		if ($fblt_faces_value == "true" && $fblt_style_value == "standard") { $optim_width = "62"; } else { $optim_width = "24"; }
		$fblt_add .= "<iframe src=\"http://www.facebook.com/plugins/like.php?href=".urlencode(get_permalink())."&amp;layout=".$fblt_style_value."&amp;show_faces=".$fblt_faces_value."&amp;width=".$fblt_width_value."&amp;action=".$fblt_verb_value."&amp;font=".$fblt_font_value."&amp;colorscheme=".$fblt_color_value."\" scrolling=\"no\" frameborder=\"0\" allowTransparency=\"true\" style=\"border:none; overflow:hidden; width:".$fblt_width_value."px; height:".$optim_width."px; \"></iframe>";
	} elseif ($method == "xfbml") {
		$fblt_font_value = str_replace("+"," ",$fblt_font_value);
		$fblt_add .= "<fb:like href=\"".get_permalink()."\" layout=\"".$fblt_style_value."\" show_faces=\"".$fblt_faces_value."\" width=\"".$fblt_width_value."\" action=\"".$fblt_verb_value."\" font=\"".$fblt_font_value."\" colorscheme=\"".$fblt_color_value."\" />";
	} else {
		echo "WP-FBLikeThis: bad parameters (".$method.")";
	}
	
	$fblt_add .= "\n</div>\n";
	
	if ($echo) {
		echo $fblt_add;
	} else {
		return $fblt_add;
	}
}

function fblikethis_post_adds($content) {
	// Added for each post
	$fblt_add = fblikethis_button(get_option('fblt_method'),false);
	return $content.$fblt_add;
}

?>